<?php
####################################################################################################################
##                                                                                                                ##
##                                           The Eye - The Spam Blocker                                           ##
##                                                                                                                ##
##                                                                      MADE BY eye(http://theeye.pe.kr)          ##
##                                                                                                                ##
##                                                                      VERSION 0.9 beta                          ##
##                                                                                                                ##
####################################################################################################################

define(DEFAULT_ALLOW_DOMAIN, "blog.naver.com,egloos.com,blog.daum.net,tistory.com,blog.paran.com,blog.empas.com");

function TheEye_AddingTrackback($target, $mother)
{
	global $configVal;

	requireComponent('Tattertools.Function.misc');

	$data = misc::fetchConfigVal($configVal);

	if(is_null($data))
	{
		$data['denyByCountry'] = 1;
		$data['countryCode'] = "KR";
		$data['allowDomain'] = DEFAULT_ALLOW_DOMAIN;
		$data['checkTrackbackIp'] = 1;
		$data['useDnsbl'] = 1;
	}

	$url = @parse_url($mother['url']);

	$isWhiteDomain = TheEye_CheckWhiteDomain($data['allowDomain'], $url['host']);

	// check country
	if($data['denyByCountry'] == 1)
	{
		if(TheEye_CheckContry($data['countryCode']) == false)
		{
			return false;
		}
	}

	// check DNSBL
	if($data['useDnsbl'] < 3)
	{
		if($data['useDnsbl'] == 2 && $isWhiteDomain == false || $data['useDnsbl'] == 1)
		{
			if(TheEye_CheckDNSBL() == false)
			{
				return false;
			}
		}
	}

	// compare hostname and ip address
	if($data['checkTrackbackIp'] == 1 && strlen($mother['url']) > 0)
	{
		$hostIp = @gethostbyname($url['host']);

		if($hostIp) if($isWhiteDomain == false && $hostIp != $_SERVER['REMOTE_ADDR'])
		{
			return false;
		}
	}

	return true;
}

function TheEye_AddingComment($target, $mother)
{
	global $configVal;

    if ($mother['secret'] ==  true) return $target;

	requireComponent('Tattertools.Function.misc');

	$data = misc::fetchConfigVal($configVal);

	if(is_null($data))
	{
		$data['denyByCountry'] = 1;
		$data['countryCode'] = "KR";
		$data['allowDomain'] = DEFAULT_ALLOW_DOMAIN;
		$data['useDnsbl'] = 1;
	}

	// check country
	if($data['denyByCountry'] == 1)
	{
		if(TheEye_CheckContry($data['countryCode']) == false)
		{
			return false;
		}
	}

	// check DNSBL
	if($data['useDnsbl'] < 3)
	{
		if($data['useDnsbl'] == 2 && TheEye_CheckWhiteDomain($data['allowDomain'], $mother['homepage']) == false || 
			$data['useDnsbl'] == 1)
		{
			if(TheEye_CheckDNSBL() == false)
			{
				return false;
			}
		}
	}

	return $target;
}

function TheEye_CheckWhiteDomain($allowDomain, $host)
{
	if(strlen($host) == 0) return true;

	$domainList = explode(",", $allowDomain);

	$isWhiteDomain = false;
	
	for($i = 0 ; $i < count($domainList) ; $i++)
	{
		if(eregi(trim($domainList[$i]), $host))
		{
			$isWhiteDomain = true;
			break;
		}
	}

	return $isWhiteDomain;
}

function TheEye_CheckContry($countryCodes)
{

	if((function_exists("geoip_open") && function_exists("geoip_country_code_by_name")) == false) return true;

	$countryCodes = explode(",", $countryCodes);

	if(count($countryCodes) > 0)
	{
		$gi = @geoip_open(GEOIP_STANDARD);
		$country = @geoip_country_code_by_name($gi, $_SERVER['REMOTE_ADDR']);
	}

	for($i = 0 ; $i < count($countryCodes) ; $i++)
	{
		$trimmedCode = trim($countryCodes[$i]);

		if(strlen($trimmedCode) == 2)
		{
			if(strtoupper($trimmedCode) == $country) return true;
		}
	}
	
	return false;
}

function TheEye_CheckDNSBL()
{
		$convertedIp = explode(".", $_SERVER['REMOTE_ADDR']);

		$resultIp = "";

		while(count($convertedIp) > 0)
		{
			if(strlen($resultIp) > 0) $resultIp .= ".";

			$resultIp .= array_pop($convertedIp);
		}

		$rblData = dns_get_record($resultIp.".zen.spamhaus.org");

		if(count($rblData) > 0) return false;
		else return true;
}

function theEyeConfig($data)
{
	requireComponent('Tattertools.Function.misc');
	$cfg = misc::fetchConfigVal($data);
	
	if($cfg['denyByCountry'] == 1)
	{
		if(function_exists("geoip_open") && function_exists("geoip_country_code_by_name") == false)
		{
			return "Geo-IP Extension ġǾ ʽϴ.      ϴ.";
		}
	}
	return true;
}

?>
